# Folding Paths that start at a single Secondary Structure

Implementation of gradient- and random walks starting from a single secondary structure.

  Defines

  VRNA_PATH_STEEPEST_DESCENT
    #include <ViennaRNA/landscape/walk.h>

    Option flag to request a steepest descent / gradient path.

    See also

    vrna_path()

  VRNA_PATH_RANDOM
    #include <ViennaRNA/landscape/walk.h>

    Option flag to request a random walk path.

    See also

    vrna_path()

  VRNA_PATH_NO_TRANSITION_OUTPUT
    #include <ViennaRNA/landscape/walk.h>

    Option flag to omit returning the transition path.

    See also

    vrna_path(), vrna_path_gradient(), vrna_path_random()

  VRNA_PATH_DEFAULT
    #include <ViennaRNA/landscape/walk.h>

    Option flag to request defaults (steepest descent / default move set)

    See also

    vrna_path(), VRNA_PATH_STEEPEST_DESCENT, VRNA_MOVESET_DEFAULT

  Functions

  vrna_move_t *vrna_path(vrna_fold_compound_t *fc, short *pt, unsigned int steps, unsigned int options)
    #include <ViennaRNA/landscape/walk.h>

    Compute a path, store the final structure, and return a list of transition moves from the start to the final structure.

    This function computes, given a start structure in pair table format, a transition path, updates the pair table to the final structure of the path. Finally, if not requested otherwise by using the VRNA_PATH_NO_TRANSITION_OUTPUT flag in the `options` field, this function returns a list of individual transitions that lead from the start to the final structure if requested.

    The currently available transition paths are

    - Steepest Descent / Gradient walk (flag: VRNA_PATH_STEEPEST_DESCENT)

    - Random walk (flag: VRNA_PATH_RANDOM)

    The type of transitions must be set through the `options` parameter

    SWIG Wrapper Notes:

      This function is attached as an overloaded method `path()` to objects of type `fold_compound`. The optional parameter `options` defaults to VRNA_PATH_DEFAULT if it is omitted. See, e.g. `RNA.fold_compound.path()` in the Python API.

    See also

    vrna_path_gradient(), vrna_path_random(), vrna_ptable(), vrna_ptable_copy(), vrna_fold_compound() VRNA_PATH_STEEPEST_DESCENT, VRNA_PATH_RANDOM, VRNA_MOVESET_DEFAULT, VRNA_MOVESET_SHIFT, VRNA_PATH_NO_TRANSITION_OUTPUT

    Note

    Since the result is written to the input structure you may want to use vrna_ptable_copy() before calling this function to keep the initial structure

    Parameters:

      - fc – [in] A vrna_fold_compound_t containing the energy parameters and model details

      - pt – [inout] The pair table containing the start structure. Used to update to the final structure after execution of this function

      - options – [in] Options to modify the behavior of this function

    Returns:

      A list of transition moves (default), or NULL (if options & VRNA_PATH_NO_TRANSITION_OUTPUT)

  vrna_move_t *vrna_path_gradient(vrna_fold_compound_t *fc, short *pt, unsigned int options)
    #include <ViennaRNA/landscape/walk.h>

    Compute a steepest descent / gradient path, store the final structure, and return a list of transition moves from the start to the final structure.

    This function computes, given a start structure in pair table format, a steepest descent path, updates the pair table to the final structure of the path. Finally, if not requested otherwise by using the VRNA_PATH_NO_TRANSITION_OUTPUT flag in the `options` field, this function returns a list of individual transitions that lead from the start to the final structure if requested.

    SWIG Wrapper Notes:

      This function is attached as an overloaded method `path_gradient()` to objects of type `fold_compound`. The optional parameter `options` defaults to VRNA_PATH_DEFAULT if it is omitted. See, e.g. `RNA.fold_compound.path_gradient()` in the Python API.

    See also

    vrna_path_random(), vrna_path(), vrna_ptable(), vrna_ptable_copy(), vrna_fold_compound() VRNA_MOVESET_DEFAULT, VRNA_MOVESET_SHIFT, VRNA_PATH_NO_TRANSITION_OUTPUT

    Note

    Since the result is written to the input structure you may want to use vrna_ptable_copy() before calling this function to keep the initial structure

    Parameters:

      - fc – [in] A vrna_fold_compound_t containing the energy parameters and model details

      - pt – [inout] The pair table containing the start structure. Used to update to the final structure after execution of this function

      - options – [in] Options to modify the behavior of this function

    Returns:

      A list of transition moves (default), or NULL (if options & VRNA_PATH_NO_TRANSITION_OUTPUT)

  vrna_move_t *vrna_path_random(vrna_fold_compound_t *fc, short *pt, unsigned int steps, unsigned int options)
    #include <ViennaRNA/landscape/walk.h>

    Generate a random walk / path of a given length, store the final structure, and return a list of transition moves from the start to the final structure.

    This function generates, given a start structure in pair table format, a random walk / path, updates the pair table to the final structure of the path. Finally, if not requested otherwise by using the VRNA_PATH_NO_TRANSITION_OUTPUT flag in the `options` field, this function returns a list of individual transitions that lead from the start to the final structure if requested.

    SWIG Wrapper Notes:

      This function is attached as an overloaded method `path_gradient()` to objects of type `fold_compound`. The optional parameter `options` defaults to VRNA_PATH_DEFAULT if it is omitted. See, e.g. `RNA.fold_compound.path_random()` in the Python API.

    See also

    vrna_path_gradient(), vrna_path(), vrna_ptable(), vrna_ptable_copy(), vrna_fold_compound() VRNA_MOVESET_DEFAULT, VRNA_MOVESET_SHIFT, VRNA_PATH_NO_TRANSITION_OUTPUT

    Note

    Since the result is written to the input structure you may want to use vrna_ptable_copy() before calling this function to keep the initial structure

    Parameters:

      - fc – [in] A vrna_fold_compound_t containing the energy parameters and model details

      - pt – [inout] The pair table containing the start structure. Used to update to the final structure after execution of this function

      - steps – [in] The length of the path, i.e. the total number of transitions / moves

      - options – [in] Options to modify the behavior of this function

    Returns:

      A list of transition moves (default), or NULL (if options & VRNA_PATH_NO_TRANSITION_OUTPUT)